tclap: TCLAP::Arg Class Reference

# TCLAP::Arg Class Reference

A virtual base class that defines the essential data for all arguments. More...

`#include <Arg.h>`

Inheritance diagram for TCLAP::Arg:

List of all members.

## Public Member Functions
virtual | ~Arg ()
| Destructor.
virtual void | addToList (std::list< Arg * > &argList) const
| Adds this to the specified list of Args.
virtual bool | processArg (int *i, std::vector< std::string > &args)=0
| Pure virtual method meant to handle the parsing and value assignment of the string on the command line.
virtual bool | operator== (const Arg &a) const
| Operator ==.
const std::string & | getFlag () const
| Returns the argument flag.
const std::string & | getName () const
| Returns the argument name.
std::string | getDescription () const
| Returns the argument description.
virtual bool | isRequired () const
| Indicates whether the argument is required.
void | forceRequired ()
| Sets _required to true.
void | xorSet ()
| Sets the _alreadySet value to true.
bool | isValueRequired () const
| Indicates whether a value must be specified for argument.
bool | isSet () const
| Indicates whether the argument has already been set.
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired.
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument.
virtual std::string | toString () const
| Returns a simple string representation of the argument.
virtual std::string | shortID (const std::string &valueId="val") const
| Returns a short ID for the usage.
virtual std::string | longID (const std::string &valueId="val") const
| Returns a long ID for the usage.
virtual void | trimFlag (std::string &flag, std::string &value) const
| Trims a value off of the flag.
bool | _hasBlanks (const std::string &s) const
| Checks whether a given string has blank chars, indicating that it is a combined SwitchArg.
void | setRequireLabel (const std::string &s)
| Sets the requireLabel.
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set.
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values.
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines.
## Static Public Member Functions
static void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified.
static bool | ignoreRest ()
| Whether to ignore the rest.
static char | delimiter ()
| The delimiter that separates an argument flag/name from the value.
static char | blankChar ()
| The char used as a place holder when SwitchArgs are combined.
static char | flagStartChar ()
static const std::string | flagStartString ()
static const std::string | nameStartString ()
static const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument.
static void | setDelimiter (char c)
| Sets the delimiter for all arguments.
## Protected Member Functions
void | _checkWithVisitor () const
| Performs the special handling described by the Vistitor.
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor.
## Protected Attributes
std::string | _flag
| The single char flag used to identify the argument.
std::string | _name
| A single work namd indentifying the argument.
std::string | _description
| Description of the argument.
bool | _required
| Indicating whether the argument is required.
std::string | _requireLabel
| Label to be used in usage description.
bool | _valueRequired
| Indicates whether a value is required for the argument.
bool | _alreadySet
| Indicates whether the argument has been set.
Visitor * | _visitor
| A pointer to a vistitor object.
bool | _ignoreable
| Whether this argument can be ignored, if desired.
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line.
bool | _acceptsMultipleValues

## Detailed Description

A virtual base class that defines the essential data for all arguments.

This class, or one of its existing children, must be subclassed to do anything.

Definition at line 64 of file Arg.h.

## Constructor & Destructor Documentation

TCLAP::Arg::Arg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | bool | valreq,
|  | Visitor * | v = `NULL` |
| ) |  |  | `[inline, protected]`

Primary constructor.

YOU (yes you) should NEVER construct an Arg directly, this is a base class that is extended by various children that are meant to be used. Use SwitchArg, ValueArg, MultiArg, UnlabeledValueArg, or UnlabeledMultiArg instead.

Parameters:

  | flag | - The flag identifying the argument.
  | name | - The name identifying the argument.
  | desc | - The description of the argument, used in the usage.
  | req | - Whether the argument is required.
  | valreq | - Whether the a value is required for the argument.
  | v | - The visitor checked by the argument. Defaults to NULL.

Definition at line 462 of file Arg.h.

References _flag, _name, flagStartString(), ignoreNameString(), nameStartString(), and toString().

TCLAP::Arg::~Arg | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 503 of file Arg.h.

## Member Function Documentation

void TCLAP::Arg::_checkWithVisitor | ( |  | ) | const`[inline, protected]`

Performs the special handling described by the Vistitor.

Definition at line 611 of file Arg.h.

References _visitor, and TCLAP::Visitor::visit().

Referenced by TCLAP::ValueArg< T >::processArg(), TCLAP::MultiSwitchArg::processArg(), and TCLAP::MultiArg< T >::processArg().

bool TCLAP::Arg::_hasBlanks | ( | const std::string & | s | ) | const`[inline]`

Checks whether a given string has blank chars, indicating that it is a combined SwitchArg.

Implementation of _hasBlanks.

If so, return true, otherwise return false.

Parameters:

  | s | - string to be checked.

Definition at line 641 of file Arg.h.

References blankChar().

Referenced by TCLAP::ValueArg< T >::processArg(), TCLAP::UnlabeledValueArg< T >::processArg(), TCLAP::UnlabeledMultiArg< T >::processArg(), and TCLAP::MultiArg< T >::processArg().

bool TCLAP::Arg::acceptsMultipleValues | ( |  | ) | `[inline, virtual]`

Use by output classes to determine whether an Arg accepts multiple values.

Definition at line 674 of file Arg.h.

References _acceptsMultipleValues.

Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::DocBookOutput::printShortArg().

void TCLAP::Arg::addToList | ( | std::list< Arg * > & | argList | ) | const`[inline, virtual]`

Adds this to the specified list of Args.

Overridden by Args that need to added to the end of the list.

Parameters:

  | argList | - The list to add this to.

Definition at line 664 of file Arg.h.

Referenced by TCLAP::CmdLine::add().

bool TCLAP::Arg::allowMore | ( |  | ) | `[inline, virtual]`

Used for MultiArgs and XorHandler to determine whether args can still be set.

Reimplemented in TCLAP::MultiArg< T >.

Definition at line 669 of file Arg.h.

bool TCLAP::Arg::argMatches | ( | const std::string & | s | ) | const`[inline, virtual]`

A method that tests whether a string matches this argument.

This is generally called by the processArg() method. This method could be re-implemented by a child to change how arguments are specified on the command line.

Parameters:

  | s | - The string to be compared to the flag/name to determine whether the arg matches.

Definition at line 590 of file Arg.h.

References _flag, _name, flagStartString(), and nameStartString().

Referenced by TCLAP::ValueArg< T >::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::MultiSwitchArg::processArg(), and TCLAP::MultiArg< T >::processArg().

static void TCLAP::Arg::beginIgnoring | ( |  | ) | `[inline, static]`

Begin ignoring arguments since the "--" argument was specified.

Definition at line 200 of file Arg.h.

Referenced by TCLAP::IgnoreRestVisitor::visit().

static char TCLAP::Arg::blankChar | ( |  | ) | `[inline, static]`

The char used as a place holder when SwitchArgs are combined.

Currently set to the bell char (ASCII 7).

Definition at line 217 of file Arg.h.

Referenced by TCLAP::CmdLine::_emptyCombined(), _hasBlanks(), and TCLAP::SwitchArg::combinedSwitchesMatch().

static char TCLAP::Arg::delimiter | ( |  | ) | `[inline, static]`

The delimiter that separates an argument flag/name from the value.

Definition at line 211 of file Arg.h.

Referenced by TCLAP::SwitchArg::combinedSwitchesMatch(), longID(), TCLAP::ValueArg< T >::processArg(), TCLAP::MultiArg< T >::processArg(), shortID(), and trimFlag().

static char TCLAP::Arg::flagStartChar | ( |  | ) | `[inline, static]`

Definition at line 226 of file Arg.h.

References TCLAP_FLAGSTARTCHAR.

Referenced by TCLAP::CmdLine::_emptyCombined(), TCLAP::ZshCompletionOutput::getMutexList(), and TCLAP::ZshCompletionOutput::printOption().

static const std::string TCLAP::Arg::flagStartString | ( |  | ) | `[inline, static]`

Definition at line 236 of file Arg.h.

References TCLAP_FLAGSTARTSTRING.

Referenced by Arg(), argMatches(), TCLAP::SwitchArg::combinedSwitchesMatch(), longID(), shortID(), and toString().

void TCLAP::Arg::forceRequired | ( |  | ) | `[inline]`

Sets _required to true.

This is used by the XorHandler. You really have no reason to ever use it.

Definition at line 650 of file Arg.h.

References _required.

std::string TCLAP::Arg::getDescription | ( |  | ) | const`[inline]`

Returns the argument description.

Definition at line 554 of file Arg.h.

References _description, _required, and _requireLabel.

Referenced by TCLAP::UnlabeledValueArg< T >::operator==(), TCLAP::UnlabeledMultiArg< T >::operator==(), and TCLAP::ZshCompletionOutput::printOption().

const std::string & TCLAP::Arg::getFlag | ( |  | ) | const`[inline]`

Returns the argument flag.

Definition at line 567 of file Arg.h.

References _flag.

Referenced by TCLAP::ZshCompletionOutput::getMutexList(), and TCLAP::ZshCompletionOutput::printOption().

const std::string & TCLAP::Arg::getName | ( |  | ) | const`[inline]`

Returns the argument name.

Definition at line 569 of file Arg.h.

References _name.

Referenced by TCLAP::ZshCompletionOutput::getMutexList(), TCLAP::UnlabeledValueArg< T >::operator==(), TCLAP::UnlabeledMultiArg< T >::operator==(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::ZshCompletionOutput::printOption().

static const std::string TCLAP::Arg::ignoreNameString | ( |  | ) | `[inline, static]`

The name used to identify the ignore rest argument.

Definition at line 250 of file Arg.h.

Referenced by Arg().

static bool TCLAP::Arg::ignoreRest | ( |  | ) | `[inline, static]`

Whether to ignore the rest.

Definition at line 205 of file Arg.h.

Referenced by TCLAP::CmdLine::parse(), TCLAP::ValueArg< T >::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::MultiSwitchArg::processArg(), and TCLAP::MultiArg< T >::processArg().

bool TCLAP::Arg::isIgnoreable | ( |  | ) | const`[inline]`

Indicates whether the argument can be ignored, if desired.

Definition at line 583 of file Arg.h.

References _ignoreable.

bool TCLAP::Arg::isRequired | ( |  | ) | const`[inline, virtual]`

Indicates whether the argument is required.

Reimplemented in TCLAP::MultiArg< T >.

Definition at line 571 of file Arg.h.

References _required.

Referenced by TCLAP::CmdLine::add(), TCLAP::XorHandler::check(), TCLAP::ZshCompletionOutput::printArg(), and TCLAP::DocBookOutput::printShortArg().

bool TCLAP::Arg::isSet | ( |  | ) | const`[inline]`

Indicates whether the argument has already been set.

Only true if the arg has been matched on the command line.

Definition at line 575 of file Arg.h.

References _alreadySet, and _xorSet.

Referenced by TCLAP::XorHandler::check().

bool TCLAP::Arg::isValueRequired | ( |  | ) | const`[inline]`

Indicates whether a value must be specified for argument.

Definition at line 573 of file Arg.h.

References _valueRequired.

Referenced by TCLAP::ZshCompletionOutput::printOption().

std::string TCLAP::Arg::longID | ( | const std::string & | valueId = `"val"` | ) | const`[inline, virtual]`

Returns a long ID for the usage.

Parameters:

  | valueId | - The value used in the id.

Reimplemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::UnlabeledMultiArg< T >, TCLAP::UnlabeledValueArg< T >, and TCLAP::ValueArg< T >.

Definition at line 523 of file Arg.h.

References _flag, _name, _valueRequired, delimiter(), flagStartString(), and nameStartString().

Referenced by TCLAP::CmdLine::add().

static const std::string TCLAP::Arg::nameStartString | ( |  | ) | `[inline, static]`

Definition at line 245 of file Arg.h.

References TCLAP_NAMESTARTSTRING.

Referenced by Arg(), argMatches(), TCLAP::SwitchArg::combinedSwitchesMatch(), TCLAP::ZshCompletionOutput::getMutexList(), longID(), TCLAP::ZshCompletionOutput::printOption(), shortID(), and toString().

bool TCLAP::Arg::operator== | ( | const Arg & | a | ) | const`[inline, virtual]`

Operator ==.

Equality operator. Must be virtual to handle unlabeled args.

Parameters:

  | a | - The Arg to be compared to this.

Definition at line 546 of file Arg.h.

References _flag, and _name.

virtual bool TCLAP::Arg::processArg | ( | int * | i,
|  | std::vector< std::string > & | args |
| ) |  |  | `[pure virtual]`

Pure virtual method meant to handle the parsing and value assignment of the string on the command line.

Parameters:

  | i | - Pointer the the current argument in the list.
  | args | - Mutable list of strings. What is passed in from main.

Implemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::SwitchArg, TCLAP::UnlabeledMultiArg< T >, TCLAP::UnlabeledValueArg< T >, and TCLAP::ValueArg< T >.

void TCLAP::Arg::reset | ( |  | ) | `[inline, virtual]`

Clears the Arg object and allows it to be reused by new command lines.

Reimplemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::SwitchArg, and TCLAP::ValueArg< T >.

Definition at line 679 of file Arg.h.

References _alreadySet, and _xorSet.

static void TCLAP::Arg::setDelimiter | ( | char | c | ) | `[inline, static]`

Sets the delimiter for all arguments.

Parameters:

  | c | - The character that delimits flags/names from values.

Definition at line 256 of file Arg.h.

void TCLAP::Arg::setRequireLabel | ( | const std::string & | s | ) | `[inline]`

Sets the requireLabel.

Used by XorHandler. You shouldn't ever use this.

Parameters:

  | s | - Set the requireLabel to this value.

Definition at line 585 of file Arg.h.

References _requireLabel.

std::string TCLAP::Arg::shortID | ( | const std::string & | valueId = `"val"` | ) | const`[inline, virtual]`

Returns a short ID for the usage.

Parameters:

  | valueId | - The value used in the id.

Reimplemented in TCLAP::MultiArg< T >, TCLAP::MultiSwitchArg, TCLAP::UnlabeledMultiArg< T >, TCLAP::UnlabeledValueArg< T >, and TCLAP::ValueArg< T >.

Definition at line 505 of file Arg.h.

References _flag, _name, _required, _valueRequired, delimiter(), flagStartString(), and nameStartString().

Referenced by TCLAP::ZshCompletionOutput::printOption(), and TCLAP::DocBookOutput::printShortArg().

std::string TCLAP::Arg::toString | ( |  | ) | const`[inline, virtual]`

Returns a simple string representation of the argument.

Primarily for debugging.

Definition at line 599 of file Arg.h.

References _flag, _name, flagStartString(), and nameStartString().

Referenced by TCLAP::ValueArg< T >::_extractValue(), TCLAP::MultiArg< T >::_extractValue(), Arg(), TCLAP::ValueArg< T >::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::MultiArg< T >::processArg(), TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg(), and TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg().

void TCLAP::Arg::trimFlag | ( | std::string & | flag,
|  | std::string & | value |
| ) |  |  | const`[inline, virtual]`

Trims a value off of the flag.

Implementation of trimFlag.

Parameters:

  | flag | - The string from which the flag and value will be trimmed. Contains the flag once the value has been trimmed.
  | value | - Where the value trimmed from the string will be stored.

Definition at line 620 of file Arg.h.

References delimiter().

Referenced by TCLAP::ValueArg< T >::processArg(), and TCLAP::MultiArg< T >::processArg().

void TCLAP::Arg::xorSet | ( |  | ) | `[inline]`

Sets the _alreadySet value to true.

This is used by the XorHandler. You really have no reason to ever use it.

Definition at line 655 of file Arg.h.

References _alreadySet, and _xorSet.

## Member Data Documentation

bool TCLAP::Arg::_acceptsMultipleValues`[protected]`

Definition at line 158 of file Arg.h.

Referenced by acceptsMultipleValues(), and TCLAP::MultiArg< T >::MultiArg().

bool TCLAP::Arg::_alreadySet`[protected]`

Indicates whether the argument has been set.

Indicates that a value on the command line has matched the name/flag of this argument and the values have been set accordingly.

Definition at line 137 of file Arg.h.

Referenced by isSet(), TCLAP::ValueArg< T >::processArg(), TCLAP::UnlabeledValueArg< T >::processArg(), TCLAP::UnlabeledMultiArg< T >::processArg(), TCLAP::MultiSwitchArg::processArg(), TCLAP::MultiArg< T >::processArg(), reset(), and xorSet().

std::string TCLAP::Arg::_description`[protected]`

Description of the argument.

Definition at line 112 of file Arg.h.

Referenced by getDescription(), TCLAP::UnlabeledValueArg< T >::operator==(), and TCLAP::UnlabeledMultiArg< T >::operator==().

std::string TCLAP::Arg::_flag`[protected]`

The single char flag used to identify the argument.

This value (preceded by a dash {-}), can be used to identify an argument on the command line. The _flag can be blank, in fact this is how unlabeled args work. Unlabeled args must override appropriate functions to get correct handling. Note that the _flag does NOT include the dash as part of the flag.

Definition at line 98 of file Arg.h.

Referenced by Arg(), argMatches(), TCLAP::SwitchArg::combinedSwitchesMatch(), getFlag(), longID(), operator==(), shortID(), and toString().

bool TCLAP::Arg::_ignoreable`[protected]`

Whether this argument can be ignored, if desired.

Definition at line 150 of file Arg.h.

Referenced by isIgnoreable(), TCLAP::ValueArg< T >::processArg(), TCLAP::SwitchArg::processArg(), TCLAP::MultiSwitchArg::processArg(), TCLAP::MultiArg< T >::processArg(), TCLAP::UnlabeledMultiArg< T >::UnlabeledMultiArg(), and TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg().

std::string TCLAP::Arg::_name`[protected]`

A single work namd indentifying the argument.

This value (preceded by two dashed {--}) can also be used to identify an argument on the command line. Note that the _name does NOT include the two dashes as part of the _name. The _name cannot be blank.

Definition at line 107 of file Arg.h.

Referenced by Arg(), argMatches(), getName(), longID(), TCLAP::UnlabeledValueArg< T >::operator==(), TCLAP::UnlabeledMultiArg< T >::operator==(), operator==(), shortID(), and toString().

bool TCLAP::Arg::_required`[protected]`

Indicating whether the argument is required.

Definition at line 117 of file Arg.h.

Referenced by forceRequired(), getDescription(), TCLAP::MultiArg< T >::isRequired(), isRequired(), and shortID().

std::string TCLAP::Arg::_requireLabel`[protected]`

Label to be used in usage description.

Normally set to "required", but can be changed when necessary.

Definition at line 123 of file Arg.h.

Referenced by getDescription(), and setRequireLabel().

bool TCLAP::Arg::_valueRequired`[protected]`

Indicates whether a value is required for the argument.

Note that the value may be required but the argument/value combination may not be, as specified by _required.

Definition at line 130 of file Arg.h.

Referenced by isValueRequired(), longID(), and shortID().

Visitor* TCLAP::Arg::_visitor`[protected]`

A pointer to a vistitor object.

The visitor allows special handling to occur as soon as the argument is matched. This defaults to NULL and should not be used unless absolutely necessary.

Definition at line 145 of file Arg.h.

Referenced by _checkWithVisitor().

bool TCLAP::Arg::_xorSet`[protected]`

Indicates that the arg was set as part of an XOR and not on the command line.

Definition at line 156 of file Arg.h.

Referenced by isSet(), TCLAP::ValueArg< T >::processArg(), reset(), and xorSet().

The documentation for this class was generated from the following file:

- Arg.h